int files_exist(size_t n) {
    FILE *fp;
    char *filename = malloc(50);

    sprintf(filename, "../common/mat/%lux%lu_a", n, n);
    fp = fopen(filename, "r");
    if (fp == NULL) return 0;
    fclose(fp);
    
    sprintf(filename, "../common/mat/%lux%lu_b", n, n);
    fp = fopen(filename, "r");
    if (fp == NULL) return 0;
    fclose(fp);

    sprintf(filename, "../common/mat/%lux%lu_c", n, n);
    fp = fopen(filename, "r");
    if (fp == NULL) return 0;
    fclose(fp);
    
    free(filename);
    return 1;
}

void load_matrix_files(float **a, float **b, float **c, size_t n) {
    FILE *fp;
    char *filename = malloc(50);
    
    *a = malloc(sizeof(**a) * n * n);
    *b = malloc(sizeof(**a) * n * n);
    *c = malloc(sizeof(**a) * n * n);
    
    int read = 0;
    sprintf(filename, "../common/mat/%lux%lu_a", n, n);
    fp = fopen(filename, "r");
    read += fread(*a, sizeof(**a), n*n, fp);
    fclose(fp);

    sprintf(filename, "../common/mat/%lux%lu_b", n, n);
    fp = fopen(filename, "r");
    read += fread(*b, sizeof(**a), n*n, fp);
    fclose(fp);

    sprintf(filename, "../common/mat/%lux%lu_c", n, n);
    fp = fopen(filename, "r");
    read += fread(*c, sizeof(**a), n*n, fp);
    fclose(fp);
    
    if (read != 3 * n * n) {
        printf("failed reading files\n");
        exit(1);
    }
    
    free(filename);
}

void write_matrix_files(float *a, float *b, float *c, size_t n) {
    FILE *fp;
    char *filename = malloc(50);

    sprintf(filename, "../common/mat/%lux%lu_a", n, n);
    fp = fopen(filename, "w");
    fwrite(a, sizeof(*a), n*n, fp);
    fclose(fp);

    sprintf(filename, "../common/mat/%lux%lu_b", n, n);
    fp = fopen(filename, "w");
    fwrite(b, sizeof(*a), n*n, fp);
    fclose(fp);
        
    sprintf(filename, "../common/mat/%lux%lu_c", n, n);
    fp = fopen(filename, "w");
    fwrite(c, sizeof(*a), n*n, fp);
    fclose(fp);
    
    free(filename);
}

