__kernel void transpose(__global float *g_mat) {
    uint size = NUMBLOCKS;
    float loc;
    int col = get_global_id(0);
    int row = 0;
    while (col >= size) {
        col -= size--;
        row++;
    }
    col += row;
    size += row;
    
    if (row != col) {
        loc = g_mat[row * size + col];
        g_mat[row * size + col] = g_mat[col * size + row];
        g_mat[col * size + row] = loc;
    }
}

__kernel void mult(__global float *a, __global float *b, __global float *c) {
    int a_row = get_global_id(0);
    int b_row = get_global_id(1);
    
    a += a_row * SIZE;
    b += b_row * SIZE;
    c += a_row * SIZE + b_row;
    
    float sum = 0.0f;
    for (int i = 0; i < SIZE; i++) {
        sum += a[i] * b[i];
    }
    c[0] = sum;
}
