__kernel __attribute__((vec_type_hint(float8))) 
void matmul(__global float8 *a, __global float *b, __global float *c) {
    int row = get_global_id(0);
    int col = get_global_id(1);
    
    float sum = 0.0f;
    for(int k = 0; k < SIZE; k += 8) {
        float8 bvec = (float8) (b[SIZE*(k+0) + col], 
                                b[SIZE*(k+1) + col], 
                                b[SIZE*(k+2) + col], 
                                b[SIZE*(k+3) + col], 
                                b[SIZE*(k+4) + col], 
                                b[SIZE*(k+5) + col], 
                                b[SIZE*(k+6) + col], 
                                b[SIZE*(k+7) + col]);
        
        sum += dot(a[(SIZE*row + k)/8].lo, bvec.lo) + dot(a[(SIZE*row + k)/8].hi, bvec.hi);
    }
    c[SIZE*row + col] = sum;
}
