__kernel __attribute__((vec_type_hint(float4)))
void matmul(__global float4 *a, __global float *b, __global float *c) {
    int row = get_global_id(0);
    int col = get_global_id(1);
    
    float sum = 0.0f;
    for(int k = 0; k < SIZE; k += 4) {
        float4 bvec = (float4) (b[SIZE*k + col], 
                                b[SIZE*(k+1) + col], 
                                b[SIZE*(k+2) + col], 
                                b[SIZE*(k+3) + col]);
        sum += dot(a[(SIZE*row + k)/4], bvec);
    }
    c[SIZE*row + col] = sum;
}
